- Elementary
- Main
- Authors
- Examples
- Files
- Pages
- Types
- Modules

Data Structures | Macros | Typedefs | Enumerations | Functions | Variables
General

General Elementary API. More...

## Data Structures
struct | _Elm_Event_Policy_Changed
| Data on the event when an Elementary policy has changed. More...

## Macros
#define | ELM_MAIN() int main(int argc, char **argv) { int ret; _elm_startup_time = ecore_time_unix_get(); elm_init(argc, argv); ret = elm_main(argc, argv); return ret; }
| macro to be used after the elm_main() function
#define | elm_object_item_text_set(it, label) elm_object_item_part_text_set((it), NULL, (label))
| Macro to set a label of an object item. More...

## Typedefs
typedef struct _Elm_Event_Policy_Changed | Elm_Event_Policy_Changed
| Data on the event when an Elementary policy has changed.
typedef Eina_Bool(* | Elm_Event_Cb )(void *data, Evas_Object *obj, Evas_Object *src, Evas_Callback_Type type, void *event_info)
| Function prototype definition for callbacks on input events happening on Elementary widgets. More...
typedef struct _Elm_Object_Item | Elm_Object_Item
| An Elementary Object item handle.
typedef void(* | Elm_Object_Item_Signal_Cb )(void *data, Elm_Object_Item *it, const char *emission, const char *source)
| Elm_Object_Item Signal Callback functions' prototype definition. More...

## Enumerations
enum | Elm_Object_Layer { ELM_OBJECT_LAYER_BACKGROUND = EVAS_LAYER_MIN + 64, ELM_OBJECT_LAYER_DEFAULT = 0, ELM_OBJECT_LAYER_FOCUS = EVAS_LAYER_MAX - 128, ELM_OBJECT_LAYER_TOOLTIP = EVAS_LAYER_MAX - 64, ELM_OBJECT_LAYER_CURSOR = EVAS_LAYER_MAX - 32, ELM_OBJECT_LAYER_LAST }
| Defines couple of standard Evas_Object layers to be used with evas_object_layer_set(). More...
enum | Elm_Policy { ELM_POLICY_QUIT, ELM_POLICY_EXIT, ELM_POLICY_THROTTLE }
| Policy identifiers. More...
enum | Elm_Policy_Quit { ELM_POLICY_QUIT_NONE = 0, ELM_POLICY_QUIT_LAST_WINDOW_CLOSED }
| Possible values for the ELM_POLICY_QUIT policy. More...
enum | Elm_Policy_Exit { ELM_POLICY_EXIT_NONE = 0, ELM_POLICY_EXIT_WINDOWS_DEL }
| Possible values for the ELM_POLICY_EXIT policy. More...
enum | Elm_Policy_Throttle { ELM_POLICY_THROTTLE_CONFIG = 0, ELM_POLICY_THROTTLE_HIDDEN_ALWAYS, ELM_POLICY_THROTTLE_NEVER }
| Possible values for the ELM_POLICY_THROTTLE policy. More...
enum | Elm_Object_Select_Mode { ELM_OBJECT_SELECT_MODE_DEFAULT = 0, ELM_OBJECT_SELECT_MODE_ALWAYS, ELM_OBJECT_SELECT_MODE_NONE, ELM_OBJECT_SELECT_MODE_DISPLAY_ONLY }
enum | Elm_Object_Multi_Select_Mode { ELM_OBJECT_MULTI_SELECT_MODE_DEFAULT = 0, ELM_OBJECT_MULTI_SELECT_MODE_WITH_CONTROL }

## Functions
EINA_DEPRECATED void | elm_object_domain_translatable_text_part_set (Evas_Object *obj, const char *part, const char *domain, const char *text)
| Set the text for an object's part, marking it as translatable. More...
EINA_DEPRECATED const char * | elm_object_translatable_text_part_get (const Evas_Object *obj, const char *part)
| Get the original string set as translatable for an object. More...
int | elm_init (int argc, char **argv)
| Initialize Elementary. More...
int | elm_shutdown (void)
| Shut down Elementary. More...
void | elm_run (void)
| Run Elementary's main loop. More...
void | elm_exit (void)
| Ask to exit Elementary's main loop. More...
void | elm_quicklaunch_mode_set (Eina_Bool ql_on)
| Exposed symbol used only by macros and should not be used by apps.
Eina_Bool | elm_quicklaunch_mode_get (void)
| Exposed symbol used only by macros and should not be used by apps.
int | elm_quicklaunch_init (int argc, char **argv)
| Exposed symbol used only by macros and should not be used by apps.
int | elm_quicklaunch_sub_init (int argc, char **argv)
| Exposed symbol used only by macros and should not be used by apps.
int | elm_quicklaunch_sub_shutdown (void)
| Exposed symbol used only by macros and should not be used by apps.
int | elm_quicklaunch_shutdown (void)
| Exposed symbol used only by macros and should not be used by apps.
void | elm_quicklaunch_seed (void)
| Exposed symbol used only by macros and should not be used by apps.
Eina_Bool | elm_quicklaunch_prepare (int argc, char **argv, const char *cwd)
| Exposed symbol used only by macros and should not be used by apps.
Eina_Bool | elm_quicklaunch_fork (int argc, char **argv, char *cwd, void(postfork_func)(void *data), void *postfork_data)
| Exposed symbol used only by macros and should not be used by apps.
void | elm_quicklaunch_cleanup (void)
| Exposed symbol used only by macros and should not be used by apps.
int | elm_quicklaunch_fallback (int argc, char **argv)
| Exposed symbol used only by macros and should not be used by apps.
char * | elm_quicklaunch_exe_path_get (const char *exe, const char *cwd)
| Exposed symbol used only by macros and should not be used by apps.
Eina_Bool | elm_policy_set (unsigned int policy, int value)
| Set a new policy's value (for a given policy group/identifier). More...
int | elm_policy_get (unsigned int policy)
| Get the policy value for given policy identifier. More...
void | elm_language_set (const char *lang)
| Change the language of the current application. More...
void | elm_object_part_text_set (Evas_Object *obj, const char *part, const char *text)
| Set a text of an object. More...
const char * | elm_object_part_text_get (const Evas_Object *obj, const char *part)
| Get a text of an object. More...
void | elm_object_domain_translatable_part_text_set (Evas_Object *obj, const char *part, const char *domain, const char *text)
| Set the text for an object's part, marking it as translatable. More...
const char * | elm_object_translatable_part_text_get (const Evas_Object *obj, const char *part)
| Get the original string set as translatable for an object. More...
void | elm_object_domain_part_text_translatable_set (Evas_Object *obj, const char *part, const char *domain, Eina_Bool translatable)
| Mark the part text to be translatable or not. More...
void | elm_object_part_content_set (Evas_Object *obj, const char *part, Evas_Object *content)
| Set the content on part of a given container widget. More...
Evas_Object * | elm_object_part_content_get (const Evas_Object *obj, const char *part)
| Get the content on a part of a given container widget. More...
Evas_Object * | elm_object_part_content_unset (Evas_Object *obj, const char *part)
| Unset the content on a part of a given container widget. More...
void | elm_object_access_info_set (Evas_Object *obj, const char *txt)
| Set the text to read out when in accessibility mode. More...
Evas_Object * | elm_object_name_find (const Evas_Object *obj, const char *name, int recurse)
| Get a named object from the children. More...
void | elm_object_disabled_set (Evas_Object *obj, Eina_Bool disabled)
| Set the disabled state of an Elementary object. More...
Eina_Bool | elm_object_disabled_get (const Evas_Object *obj)
| Get the disabled state of an Elementary object. More...
void | elm_object_signal_emit (Evas_Object *obj, const char *emission, const char *source)
| Send a signal to the widget edje object. More...
void | elm_object_signal_callback_add (Evas_Object *obj, const char *emission, const char *source, Edje_Signal_Cb func, void *data)
| Add a callback for a signal emitted by widget edje object. More...
void * | elm_object_signal_callback_del (Evas_Object *obj, const char *emission, const char *source, Edje_Signal_Cb func)
| Remove a signal-triggered callback from a widget edje object. More...
void | elm_object_event_callback_add (Evas_Object *obj, Elm_Event_Cb func, const void *data)
| Add a callback for input events (key up, key down, mouse wheel) on a given Elementary widget. More...
void * | elm_object_event_callback_del (Evas_Object *obj, Elm_Event_Cb func, const void *data)
| Remove an event callback from a widget. More...
void | elm_object_orientation_mode_disabled_set (Evas_Object *obj, Eina_Bool disabled)
| Disable the orientation mode of a given widget. More...
Eina_Bool | elm_object_orientation_mode_disabled_get (const Evas_Object *obj)
| Get the orientation mode of a given widget. More...
Evas_Object * | elm_object_item_widget_get (const Elm_Object_Item *it)
| Get the widget object's handle which contains a given item. More...
void | elm_object_item_part_content_set (Elm_Object_Item *it, const char *part, Evas_Object *content)
| Set a content of an object item. More...
Evas_Object * | elm_object_item_part_content_get (const Elm_Object_Item *it, const char *part)
| Get a content of an object item. More...
Evas_Object * | elm_object_item_part_content_unset (Elm_Object_Item *it, const char *part)
| Unset a content of an object item. More...
void | elm_object_item_part_text_set (Elm_Object_Item *it, const char *part, const char *label)
| Set a label of an object item. More...
const char * | elm_object_item_part_text_get (const Elm_Object_Item *it, const char *part)
| Get a label of an object item. More...
void | elm_object_item_domain_translatable_part_text_set (Elm_Object_Item *it, const char *part, const char *domain, const char *text)
| Set the text for an object item's part, marking it as translatable. More...
const char * | elm_object_item_translatable_part_text_get (const Elm_Object_Item *it, const char *part)
| Get the original string set as translatable for an object item. More...
void | elm_object_item_domain_part_text_translatable_set (Elm_Object_Item *it, const char *part, const char *domain, Eina_Bool translatable)
| Mark the part text to be translatable or not. More...
void | elm_object_item_access_info_set (Elm_Object_Item *it, const char *txt)
| Set the text to read out when in accessibility mode. More...
Evas_Object * | elm_object_item_access_register (Elm_Object_Item *item)
| Register object item as an accessible object. More...
void | elm_object_item_access_unregister (Elm_Object_Item *item)
| Unregister accessible object of the object item. More...
Evas_Object * | elm_object_item_access_object_get (const Elm_Object_Item *item)
| Get an accessible object of the object item. More...
void | elm_object_item_access_order_set (Elm_Object_Item *item, Eina_List *objs)
| Set highlight order. More...
const Eina_List * | elm_object_item_access_order_get (const Elm_Object_Item *item)
| Get highlight order. More...
void | elm_object_item_access_order_unset (Elm_Object_Item *item)
| Unset highlight order. More...
void * | elm_object_item_data_get (const Elm_Object_Item *it)
| Get the data associated with an object item. More...
void | elm_object_item_data_set (Elm_Object_Item *it, void *data)
| Set the data associated with an object item. More...
void | elm_object_item_signal_emit (Elm_Object_Item *it, const char *emission, const char *source)
| Send a signal to the edje object of the widget item. More...
void | elm_object_item_signal_callback_add (Elm_Object_Item *it, const char *emission, const char *source, Elm_Object_Item_Signal_Cb func, void *data)
| Add a callback for a signal emitted by object item edje. More...
void * | elm_object_item_signal_callback_del (Elm_Object_Item *it, const char *emission, const char *source, Elm_Object_Item_Signal_Cb func)
| Remove a signal-triggered callback from a object item edje object. More...
void | elm_object_item_del_cb_set (Elm_Object_Item *it, Evas_Smart_Cb del_cb)
| Set the function to be called when an item from the widget is freed. More...
void | elm_object_item_del (Elm_Object_Item *it)
| Delete the given item. More...
void | elm_object_item_tooltip_text_set (Elm_Object_Item *it, const char *text)
| Set the text to be shown in a given object item's tooltips. More...
void | elm_object_item_tooltip_content_cb_set (Elm_Object_Item *it, Elm_Tooltip_Item_Content_Cb func, const void *data, Evas_Smart_Cb del_cb)
| Set the content to be shown in the tooltip item. More...
void | elm_object_item_tooltip_unset (Elm_Object_Item *it)
| Unset tooltip from item. More...
void | elm_object_item_tooltip_style_set (Elm_Object_Item *it, const char *style)
| Sets a different style for this item tooltip. More...
const char * | elm_object_item_tooltip_style_get (const Elm_Object_Item *it)
| Get the style for this item tooltip. More...
void | elm_object_item_cursor_set (Elm_Object_Item *it, const char *cursor)
| Set the type of mouse pointer/cursor decoration to be shown, when the mouse pointer is over the given item. More...
void | elm_object_item_cursor_unset (Elm_Object_Item *it)
| Unset any custom mouse pointer/cursor decoration set to be shown, when the mouse pointer is over the given item, thus making it show the default cursor again. More...
void | elm_object_item_cursor_style_set (Elm_Object_Item *it, const char *style)
| Set a different style for a given custom cursor set for an item. More...
const char * | elm_object_item_cursor_style_get (const Elm_Object_Item *it)
| Get the current style set for a given item's custom cursor. More...
void | elm_object_item_cursor_engine_only_set (Elm_Object_Item *it, Eina_Bool engine_only)
| Set if the (custom)cursor for a given item should be searched in its theme, also, or should only rely on the rendering engine. More...
Eina_Bool | elm_object_item_cursor_engine_only_get (const Elm_Object_Item *it)
| Get if the (custom) cursor for a given item is being searched in its theme, also, or is only relying on the rendering engine. More...
Evas_Object * | elm_object_item_track (Elm_Object_Item *it)
| This returns track object of the item. More...
void | elm_object_item_untrack (Elm_Object_Item *it)
| This retrieve the track object of the item. More...
int | elm_object_item_track_get (const Elm_Object_Item *it)
| Get the track object reference count. More...

## Variables
int | ELM_EVENT_CONFIG_ALL_CHANGED
| Emitted when the application has reconfigured elementary settings due to an external configuration tool asking it to.
int | ELM_EVENT_POLICY_CHANGED
| Emitted when any Elementary's policy value is changed.

## Detailed Description

General Elementary API.

Functions that don't relate to Elementary objects specifically.

Here are documented functions which init/shutdown the library, that apply to generic Elementary objects, that deal with configuration, et cetera.

This example contemplates some of these functions.

## Macro Definition Documentation

#define elm_object_item_text_set | ( |  | it,
|  |  | label
| ) |  | elm_object_item_part_text_set((it), NULL, (label))

Macro to set a label of an object item.

Parameters

  it | The Elementary object item.
  label | The new text of the label.

Note
  Elementary object items may have many labels.

Examples:
  popup_example_03.c, segment_control_example.c, and web_example_02.c.

## Typedef Documentation

typedef Eina_Bool(* Elm_Event_Cb)(void *data, Evas_Object *obj, Evas_Object *src, Evas_Callback_Type type, void *event_info)

Function prototype definition for callbacks on input events happening on Elementary widgets.

data will receive the user data pointer passed to elm_object_event_callback_add(). src will be a pointer to the widget on which the input event took place. type will get the type of this event and event_info, the struct with details on this event.

Examples:
  flipselector_example.c.

Elm_Object_Item_Signal_Cb

Elm_Object_Item Signal Callback functions' prototype definition.

`data` will have the auxiliary data pointer at the time the callback registration. `it` will be a pointer the Elm_Object_Item that have the edje object where the signal comes from. `emission` will identify the exact signal's emission string and `source` the exact signal's source one.

See Also
  elm_object_item_signal_callback_add()

Since
  1.8

## Enumeration Type Documentation

enum Elm_Object_Layer

Defines couple of standard Evas_Object layers to be used with evas_object_layer_set().

Note
  whenever extending with new values, try to keep some padding to siblings so there is room for further extensions.

Enumerator
ELM_OBJECT_LAYER_BACKGROUND | where to place backgrounds
ELM_OBJECT_LAYER_DEFAULT | Evas_Object default layer (and thus for Elementary)
ELM_OBJECT_LAYER_FOCUS | where focus object visualization is
ELM_OBJECT_LAYER_TOOLTIP | where to show tooltips
ELM_OBJECT_LAYER_CURSOR | where to show cursors
ELM_OBJECT_LAYER_LAST | last layer known by Elementary

enum Elm_Object_Multi_Select_Mode

Enumerator
ELM_OBJECT_MULTI_SELECT_MODE_DEFAULT | default multiple select mode
ELM_OBJECT_MULTI_SELECT_MODE_WITH_CONTROL | disallow mutiple selection when clicked without control key pressed

enum Elm_Object_Select_Mode

Enumerator
ELM_OBJECT_SELECT_MODE_DEFAULT | default select mode
ELM_OBJECT_SELECT_MODE_ALWAYS | always select mode
ELM_OBJECT_SELECT_MODE_NONE | no select mode
ELM_OBJECT_SELECT_MODE_DISPLAY_ONLY | no select mode with no finger size rule

enum Elm_Policy

Policy identifiers.

Enumerator
ELM_POLICY_QUIT | under which circumstances the application should quit automatically. See Also Elm_Policy_Quit.
ELM_POLICY_EXIT | defines elm_exit() behaviour. See Also Elm_Policy_Exit. Since 1.8
ELM_POLICY_THROTTLE | defines how throttling should work See Also Elm_Policy_Throttle Since 1.8

enum Elm_Policy_Exit

Possible values for the ELM_POLICY_EXIT policy.

Since
  1.8

Enumerator
ELM_POLICY_EXIT_NONE | just quit the main loop on elm_exit()
ELM_POLICY_EXIT_WINDOWS_DEL | delete all the windows after quitting the main loop

enum Elm_Policy_Quit

Possible values for the ELM_POLICY_QUIT policy.

Enumerator
ELM_POLICY_QUIT_NONE | never quit the application automatically
ELM_POLICY_QUIT_LAST_WINDOW_CLOSED | quit when the application's last window is closed

enum Elm_Policy_Throttle

Possible values for the ELM_POLICY_THROTTLE policy.

Since
  1.8

Enumerator
ELM_POLICY_THROTTLE_CONFIG | do whatever elementary config is configured to do
ELM_POLICY_THROTTLE_HIDDEN_ALWAYS | always throttle when all windows are no longer visible
ELM_POLICY_THROTTLE_NEVER | never throttle when windows are all hidden, regardless of config settings

## Function Documentation

void elm_exit | ( | void |  | ) |

Ask to exit Elementary's main loop.

If this call is issued, it will flag the main loop to cease processing and return back to its parent function (usually your elm_main() function). This does not mean the main loop instantly quits. So your ecore callbacks(timer, animator, event, job, and etc.) have chances to be called even after elm_exit().

See Also
  elm_init() for an example. There, just after a request to close the window comes, the main loop will be left.

Note
  By using the appropriate ELM_POLICY_QUIT on your Elementary applications, you'll be able to get this function called automatically for you.

Examples:
  button_example_00.c, fileselector_example.c, progressbar_example.c, and win_example.c.

References ELM_POLICY_EXIT, ELM_POLICY_EXIT_WINDOWS_DEL, and elm_policy_get().

int elm_init | ( | int | argc,
|  | char ** | argv
| ) |  |

Initialize Elementary.

Parameters

  [in] | argc | System's argument count value
  [in] | argv | System's pointer to array of argument strings

Returns
  The init counter value.

This function initializes Elementary and increments a counter of the number of calls to it. It returns the new counter's value.

Warning
  This call is exported only for use by the `ELM_MAIN()` macro. There is no need to use this if you use this macro (which is highly advisable). An elm_main() should contain the entry point code for your application, having the same prototype as elm_init(), and not being static (putting the `EAPI_MAIN` symbol in front of its type declaration is advisable). The `ELM_MAIN()` call should be placed just after it.

Example:

ELM_MAIN()

See the full example.

See Also
  elm_shutdown().

References elm_quicklaunch_init(), and elm_quicklaunch_sub_init().

void elm_language_set | ( | const char * | lang | ) |

Change the language of the current application.

The `lang` passed must be the full name of the locale to use, for example "en_US.utf8" or "es_ES@euro".

Changing language with this function will make Elementary run through all its widgets, translating strings set with elm_object_domain_translatable_part_text_set(). This way, an entire UI can have its language changed without having to restart the program.

For more complex cases, like having formatted strings that need translation, widgets will also emit a "language,changed" signal that the user can listen to and manually translate the text.

Parameters

  lang | Language to set, must be the full name of the locale

void elm_object_access_info_set | ( | Evas_Object * | obj,
|  | const char * | txt
| ) |  |

Set the text to read out when in accessibility mode.

Parameters

  obj | The object which is to be described
  txt | The text that describes the widget to people with poor or no vision

Eina_Bool elm_object_disabled_get | ( | const Evas_Object * | obj | ) |

Get the disabled state of an Elementary object.

Parameters

  obj | The Elementary object to operate on

Returns
  `EINA_TRUE`, if the widget is disabled, `EINA_FALSE` if it's enabled (or on errors)

This gets the state of the widget, which might be enabled or disabled.

void elm_object_disabled_set | ( | Evas_Object * | obj,
|  | Eina_Bool | disabled
| ) |  |

Set the disabled state of an Elementary object.

Parameters

  obj | The Elementary object to operate on
  disabled | The state to put in in: `EINA_TRUE` for disabled, `EINA_FALSE` for enabled

Elementary objects can be disabled, in which state they won't receive input and, in general, will be themed differently from their normal state, usually greyed out. Useful for contexts where you don't want your users to interact with some of the parts of you interface.

This sets the state for the widget, either disabling it or enabling it back.

void elm_object_domain_part_text_translatable_set | ( | Evas_Object * | obj,
|  | const char * | part,
|  | const char * | domain,
|  | Eina_Bool | translatable
| ) |  |

Mark the part text to be translatable or not.

Once you mark the part text to be translatable, the text will be translated internally regardless of elm_object_part_text_set() and elm_object_domain_translatable_part_text_set(). In other case, if you set the Elementary policy that all text will be translatable in default, you can set the part text to not be translated by calling this API.

Parameters

  obj | The object containing the text part
  part | The part name of the translatable text
  domain | The translation domain to use
  translatable | `EINA_TRUE`, the part text will be translated internally. `EINA_FALSE`, otherwise.

See Also
  elm_object_domain_translatable_part_text_set()
  elm_object_part_text_set()
  elm_policy()

Since
  1.8

void elm_object_domain_translatable_part_text_set | ( | Evas_Object * | obj,
|  | const char * | part,
|  | const char * | domain,
|  | const char * | text
| ) |  |

Set the text for an object's part, marking it as translatable.

The string to set as `text` must be the original one. Do not pass the return of `gettext()` here. Elementary will translate the string internally and set it on the object using elm_object_part_text_set(), also storing the original string so that it can be automatically translated when the language is changed with elm_language_set().

The `domain` will be stored along to find the translation in the correct catalog. It can be NULL, in which case it will use whatever domain was set by the application with `textdomain()`. This is useful in case you are building a library on top of Elementary that will have its own translatable strings, that should not be mixed with those of programs using the library.

Parameters

  obj | The object containing the text part
  part | The name of the part to set
  domain | The translation domain to use
  text | The original, non-translated text to set

Since
  1.8

Referenced by elm_object_domain_translatable_text_part_set().

EINA_DEPRECATED void elm_object_domain_translatable_text_part_set | ( | Evas_Object * | obj,
|  | const char * | part,
|  | const char * | domain,
|  | const char * | text
| ) |  |

Set the text for an object's part, marking it as translatable.

The string to set as `text` must be the original one. Do not pass the return of `gettext()` here. Elementary will translate the string internally and set it on the object using elm_object_part_text_set(), also storing the original string so that it can be automatically translated when the language is changed with elm_language_set().

The `domain` will be stored along to find the translation in the correct catalog. It can be NULL, in which case it will use whatever domain was set by the application with `textdomain()`. This is useful in case you are building a library on top of Elementary that will have its own translatable strings, that should not be mixed with those of programs using the library.

Parameters

  obj | The object containing the text part
  part | The name of the part to set
  domain | The translation domain to use
  text | The original, non-translated text to set

Deprecated:
  Use elm_object_domain_translatable_part_text_set() instead.

References elm_object_domain_translatable_part_text_set().

void elm_object_event_callback_add | ( | Evas_Object * | obj,
|  | Elm_Event_Cb | func,
|  | const void * | data
| ) |  |

Add a callback for input events (key up, key down, mouse wheel) on a given Elementary widget.

Parameters

  obj | The widget to add an event callback on
  func | The callback function to be executed when the event happens
  data | Data to pass in to `func`

Every widget in an Elementary interface set to receive focus, with elm_object_focus_allow_set(), will propagate all of its key up, key down and mouse wheel input events up to its parent object, and so on. All of the focusable ones in this chain which had an event callback set, with this call, will be able to treat those events. There are two ways of making the propagation of these event upwards in the tree of widgets to cease:

- Just return `EINA_TRUE` on `func`. `EINA_FALSE` will mean the event was not processed, so the propagation will go on.
- The `event_info` pointer passed to `func` will contain the event's structure and, if you OR its `event_flags` inner value to `EVAS_EVENT_FLAG_ON_HOLD`, you're telling Elementary one has already handled it, thus killing the event's propagation, too.

Note
  Your event callback will be issued on those events taking place only if no other child widget of `obj` has consumed the event already.
  Not to be confused with `evas_object_event_callback_add()`, which will add event callbacks per type on general Evas objects (no event propagation infrastructure taken in account).
  Not to be confused with `elm_object_signal_callback_add()`, which will add callbacks to signals coming from a widget's theme, not input events.
  Not to be confused with `edje_object_signal_callback_add()`, which does the same as elm_object_signal_callback_add(), but directly on an Edje object.
  Not to be confused with `evas_object_smart_callback_add()`, which adds callbacks to smart objects' smart events, and not input events.

See Also
  elm_object_event_callback_del()

void* elm_object_event_callback_del | ( | Evas_Object * | obj,
|  | Elm_Event_Cb | func,
|  | const void * | data
| ) |  |

Remove an event callback from a widget.

This function removes a callback, previously attached to event emission by the `obj`. The parameters func and data must match exactly those passed to a previous call to elm_object_event_callback_add(). The data pointer that was passed to this call will be returned.

Parameters

  obj | The object
  func | The callback function to be executed when the event is emitted.
  data | Data to pass in to the callback function.

Returns
  The data pointer

void elm_object_item_access_info_set | ( | Elm_Object_Item * | it,
|  | const char * | txt
| ) |  |

Set the text to read out when in accessibility mode.

Parameters

  it | The object item which is to be described
  txt | The text that describes the widget to people with poor or no vision

Evas_Object* elm_object_item_access_object_get | ( | const Elm_Object_Item * | item | ) |

Get an accessible object of the object item.

Since
  1.8

Parameters

  item | The elementary object item

Returns
  Accessible object of the object item or NULL for any error

const Eina_List* elm_object_item_access_order_get | ( | const Elm_Object_Item * | item | ) |

Get highlight order.

Since
  1.8

Parameters

  item | The container object item

Returns
  Order of objects to pass highlight

void elm_object_item_access_order_set | ( | Elm_Object_Item * | item,
|  | Eina_List * | objs
| ) |  |

Set highlight order.

Since
  1.8

Parameters

  item | The container object item
  objs | Order of objects to pass highlight

void elm_object_item_access_order_unset | ( | Elm_Object_Item * | item | ) |

Unset highlight order.

Since
  1.8

Parameters

  item | The container object item

Evas_Object* elm_object_item_access_register | ( | Elm_Object_Item * | item | ) |

Register object item as an accessible object.

Since
  1.8

Parameters

  item | The elementary object item

Returns
  Accessible object of the object item or NULL for any error

void elm_object_item_access_unregister | ( | Elm_Object_Item * | item | ) |

Unregister accessible object of the object item.

Since
  1.8

Parameters

  item | The elementary object item

Eina_Bool elm_object_item_cursor_engine_only_get | ( | const Elm_Object_Item * | it | ) |

Get if the (custom) cursor for a given item is being searched in its theme, also, or is only relying on the rendering engine.

Parameters

  it | an object item

Returns
  `EINA_TRUE`, if cursors are being looked for only on those provided by the rendering engine, `EINA_FALSE` if they are being searched on the widget's theme, as well.

See Also
  elm_object_item_cursor_engine_only_set(), for more details

void elm_object_item_cursor_engine_only_set | ( | Elm_Object_Item * | it,
|  | Eina_Bool | engine_only
| ) |  |

Set if the (custom)cursor for a given item should be searched in its theme, also, or should only rely on the rendering engine.

Parameters

  it | item with custom (custom) cursor already set on
  engine_only | Use `EINA_TRUE` to have cursors looked for only on those provided by the rendering engine, `EINA_FALSE` to have them searched on the widget's theme, as well.

Note
  This call is of use only if you've set a custom cursor for items, with elm_object_item_cursor_set().
  By default, cursors will only be looked for between those provided by the rendering engine.

void elm_object_item_cursor_set | ( | Elm_Object_Item * | it,
|  | const char * | cursor
| ) |  |

Set the type of mouse pointer/cursor decoration to be shown, when the mouse pointer is over the given item.

Parameters

  it | item to customize cursor on
  cursor | the cursor type's name

This function works analogously as elm_object_cursor_set(), but here the cursor's changing area is restricted to the item's area, and not the whole widget's. Note that that item cursors have precedence over widget cursors, so that a mouse over an item with custom cursor set will always show that cursor.

If this function is called twice for an object, a previously set cursor will be unset on the second call.

See Also
  elm_object_cursor_set()
  elm_object_item_cursor_get()
  elm_object_item_cursor_unset()

const char* elm_object_item_cursor_style_get | ( | const Elm_Object_Item * | it | ) |

Get the current style set for a given item's custom cursor.

Parameters

  it | item with custom cursor set.

Returns
  style the cursor style in use. If the object does not have a cursor set, then `NULL` is returned.

See Also
  elm_object_item_cursor_style_set() for more details

void elm_object_item_cursor_style_set | ( | Elm_Object_Item * | it,
|  | const char * | style
| ) |  |

Set a different style for a given custom cursor set for an item.

Parameters

  it | item with custom cursor set
  style | the theme style to use (e.g. `"default"`, `"transparent"`, etc)

This function only makes sense when one is using custom mouse cursor decorations defined in a theme file, which can have, given a cursor name/type, alternate styles on it. It works analogously as elm_object_cursor_style_set(), but here applies only to item objects.

Warning
  Before you set a cursor style you should have defined a custom cursor previously on the item, with elm_object_item_cursor_set()

See Also
  elm_object_item_cursor_engine_only_set()
  elm_object_item_cursor_style_get()

void elm_object_item_cursor_unset | ( | Elm_Object_Item * | it | ) |

Unset any custom mouse pointer/cursor decoration set to be shown, when the mouse pointer is over the given item, thus making it show the default cursor again.

Parameters

  it | the item

Use this call to undo any custom settings on this item's cursor decoration, bringing it back to defaults (no custom style set).

See Also
  elm_object_cursor_unset()
  elm_object_item_cursor_set()

void* elm_object_item_data_get | ( | const Elm_Object_Item * | it | ) |

Get the data associated with an object item.

Parameters

  it | The Elementary object item

Returns
  The data associated with `it`

Note
  Every elm_object_item supports this API

void elm_object_item_data_set | ( | Elm_Object_Item * | it,
|  | void * | data
| ) |  |

Set the data associated with an object item.

Parameters

  it | The Elementary object item
  data | The data to be associated with `it`

Note
  Every elm_object_item supports this API

void elm_object_item_del | ( | Elm_Object_Item * | it | ) |

Delete the given item.

Parameters

  it | The item to be deleted.

Referenced by elm_menu_item_subitems_clear().

void elm_object_item_del_cb_set | ( | Elm_Object_Item * | it,
|  | Evas_Smart_Cb | del_cb
| ) |  |

Set the function to be called when an item from the widget is freed.

Parameters

  it | The item to set the callback on
  del_cb | The function called

That function will receive these parameters:

- void * item data
- Evas_Object * widget object
- Elm_Object_Item * widget item

Note
  Every elm_object_item supports this API

See Also
  elm_object_item_del()

void elm_object_item_domain_part_text_translatable_set | ( | Elm_Object_Item * | it,
|  | const char * | part,
|  | const char * | domain,
|  | Eina_Bool | translatable
| ) |  |

Mark the part text to be translatable or not.

Once you mark the part text to be translatable, the text will be translated internally regardless of elm_object_item_part_text_set() and elm_object_item_domain_translatable_part_text_set(). In other case, if you set the Elementary policy that all text will be translatable in default, you can set the part text to not be translated by calling this API.

Parameters

  it | The object item containing the text part
  part | The part name of the translatable text
  domain | The translation domain to use
  translatable | `EINA_TRUE`, the part text will be translated internally. `EINA_FALSE`, otherwise.

See Also
  elm_object_item_domain_translatable_part_text_set()
  elm_object_item_part_text_set()
  elm_policy()

Since
  1.8

void elm_object_item_domain_translatable_part_text_set | ( | Elm_Object_Item * | it,
|  | const char * | part,
|  | const char * | domain,
|  | const char * | text
| ) |  |

Set the text for an object item's part, marking it as translatable.

The string to set as `text` must be the original one. Do not pass the return of `gettext()` here. Elementary will translate the string internally and set it on the object item using elm_object_item_part_text_set(), also storing the original string so that it can be automatically translated when the language is changed with elm_language_set(). The `domain` will be stored along to find the translation in the correct catalog. It can be NULL, in which case it will use whatever domain was set by the application with `textdomain()`. This is useful in case you are building a library on top of Elementary that will have its own translatable strings, that should not be mixed with those of programs using the library.

Parameters

  it | The object item containing the text part
  part | The name of the part to set
  domain | The translation domain to use
  text | The original, non-translated text to set

Since
  1.8

Evas_Object* elm_object_item_part_content_get | ( | const Elm_Object_Item * | it,
|  | const char * | part
| ) |  |

Get a content of an object item.

Parameters

  it | The Elementary object item
  part | The content part name to unset (NULL for the default content)

Returns
  content of the object item or NULL for any error

Note
  Elementary object items may have many contents

void elm_object_item_part_content_set | ( | Elm_Object_Item * | it,
|  | const char * | part,
|  | Evas_Object * | content
| ) |  |

Set a content of an object item.

Parameters

  it | The Elementary object item
  part | The content part name to set (NULL for the default content)
  content | The new content of the object item

This sets a new object to an item as a content object. If any object was already set as a content object in the same part, previous object will be deleted automatically.

Note
  Elementary object items may have many contents

Evas_Object* elm_object_item_part_content_unset | ( | Elm_Object_Item * | it,
|  | const char * | part
| ) |  |

Unset a content of an object item.

Parameters

  it | The Elementary object item
  part | The content part name to unset (NULL for the default content)

Note
  Elementary object items may have many contents

const char* elm_object_item_part_text_get | ( | const Elm_Object_Item * | it,
|  | const char * | part
| ) |  |

Get a label of an object item.

Parameters

  it | The Elementary object item
  part | The text part name to get (NULL for the default label)

Returns
  text of the label or NULL for any error

Note
  Elementary object items may have many labels

void elm_object_item_part_text_set | ( | Elm_Object_Item * | it,
|  | const char * | part,
|  | const char * | label
| ) |  |

Set a label of an object item.

Parameters

  it | The Elementary object item
  part | The text part name to set (NULL for the default label)
  label | The new text of the label

Note
  Elementary object items may have many labels

void elm_object_item_signal_callback_add | ( | Elm_Object_Item * | it,
|  | const char * | emission,
|  | const char * | source,
|  | Elm_Object_Item_Signal_Cb | func,
|  | void * | data
| ) |  |

Add a callback for a signal emitted by object item edje.

This function connects a callback function to a signal emitted by the edje object of the object item. Globs can occur in either the emission or source name.

Parameters

  it | The elementary object item
  emission | The signal's name.
  source | The signal's source.
  func | The callback function to be executed when the signal is emitted.
  data | A pointer to data to pass to the callback function.

Since
  1.8

void* elm_object_item_signal_callback_del | ( | Elm_Object_Item * | it,
|  | const char * | emission,
|  | const char * | source,
|  | Elm_Object_Item_Signal_Cb | func
| ) |  |

Remove a signal-triggered callback from a object item edje object.

Parameters

  it | The elementary object item
  emission | The signal's name.
  source | The signal's source.
  func | The callback function to be executed when the signal is emitted.

Returns
  The data pointer of the signal callback or `NULL`, on errors.

This function removes the last callback, previously attached to a signal emitted by an underlying Edje object of it, whose parameters emission, source and `func` match exactly with those passed to a previous call to elm_object_item_signal_callback_add(). The data pointer that was passed to this call will be returned.

See Also
  elm_object_item_signal_callback_add()

Since
  1.8

void elm_object_item_signal_emit | ( | Elm_Object_Item * | it,
|  | const char * | emission,
|  | const char * | source
| ) |  |

Send a signal to the edje object of the widget item.

This function sends a signal to the edje object of the obj item. An edje program can respond to a signal by specifying matching 'signal' and 'source' fields.

Parameters

  it | The Elementary object item
  emission | The signal's name.
  source | The signal's source.

void elm_object_item_tooltip_content_cb_set | ( | Elm_Object_Item * | it,
|  | Elm_Tooltip_Item_Content_Cb | func,
|  | const void * | data,
|  | Evas_Smart_Cb | del_cb
| ) |  |

Set the content to be shown in the tooltip item.

Setup the tooltip to item. The item can have only one tooltip, so any previous tooltip data is removed. `func`(with `data`) will be called every time that need show the tooltip and it should return a valid Evas_Object. This object is then managed fully by tooltip system and is deleted when the tooltip is gone.

Parameters

  it | the object item being attached a tooltip.
  func | the function used to create the tooltip contents.
  data | what to provide to func as callback data/context.
  del_cb | called when data is not needed anymore, either when another callback replaces func, the tooltip is unset with elm_object_item_tooltip_unset() or the owner item dies. This callback receives as the first parameter the given data, and `event_info` is the item.

See Also
  elm_object_tooltip_content_cb_set() for more details.

const char* elm_object_item_tooltip_style_get | ( | const Elm_Object_Item * | it | ) |

Get the style for this item tooltip.

Parameters

  it | object item with tooltip already set.

Returns
  style the theme style in use, defaults to "default". If the object does not have a tooltip set, then NULL is returned.

See Also
  elm_object_tooltip_style_get() for more details.
  elm_object_item_tooltip_style_set()

Referenced by elm_genlist_item_tooltip_style_get().

void elm_object_item_tooltip_style_set | ( | Elm_Object_Item * | it,
|  | const char * | style
| ) |  |

Sets a different style for this item tooltip.

Note
  before you set a style you should define a tooltip with elm_object_item_tooltip_content_cb_set() or elm_object_item_tooltip_text_set()

Parameters

  it | object item with tooltip already set.
  style | the theme style to use (default, transparent, ...)

See Also
  elm_object_tooltip_style_set() for more details.

void elm_object_item_tooltip_text_set | ( | Elm_Object_Item * | it,
|  | const char * | text
| ) |  |

Set the text to be shown in a given object item's tooltips.

Parameters

  it | Target item.
  text | The text to set in the content.

Setup the text as tooltip to object. The item can have only one tooltip, so any previous tooltip data - set with this function or elm_object_item_tooltip_content_cb_set() - is removed.

See Also
  elm_object_tooltip_text_set() for more details.

void elm_object_item_tooltip_unset | ( | Elm_Object_Item * | it | ) |

Unset tooltip from item.

Parameters

  it | object item to remove previously set tooltip.

Remove tooltip from item. The callback provided as del_cb to elm_object_item_tooltip_content_cb_set() will be called to notify it is not used anymore.

See Also
  elm_object_tooltip_unset() for more details.
  elm_object_item_tooltip_content_cb_set()

Evas_Object* elm_object_item_track | ( | Elm_Object_Item * | it | ) |

This returns track object of the item.

Parameters

  it | The Elementary Object Item to be tracked.

Returns
  The track object.

Note
  This gets a rectangle object that represents the object item's internal object. If you wanna check the geometry, visibility of the item, you can call the evas apis such as evas_object_geometry_get(), evas_object_visible_get() to the track object. Note that all of the widget items may/may not have the internal object so this api may return `NULL` if the widget item doesn't have it. Additionally, the widget item is managed/controlled by the widget, the widget item could be changed(moved, resized even deleted) anytime by it's own widget's decision. So please dont' change the track object as well as don't keep the track object in your side as possible but get the track object at the moment you need to refer. Otherwise, you need to add some callbacks to the track object to track it's attributes changes.

Warning
  After use the track object, please call the elm_object_item_untrack() paired to elm_object_item_track() definitely to free the track object properly. Don't delete the track object.

See Also
  elm_object_item_untrack()
  elm_object_item_track_get()

Since
  1.8

int elm_object_item_track_get | ( | const Elm_Object_Item * | it | ) |

Get the track object reference count.

Parameters

  it | The Elementary Object Item that returned track object.

Note
  This gets the reference count for the track object. Whenever you call the elm_object_item_track(), the reference count will be increased by one. Likely the referece count will be decreased again when you call the elm_object_item_untrack(). Unless the reference count reaches to zero, the track object won't be deleted. So please be sure to call elm_object_item_untrack() paired to the elm_object_item_track() call count.

See Also
  elm_object_item_track()
  elm_object_item_track_get()

Since
  1.8

const char* elm_object_item_translatable_part_text_get | ( | const Elm_Object_Item * | it,
|  | const char * | part
| ) |  |

Get the original string set as translatable for an object item.

When setting translated strings, the function elm_object_item_part_text_get() will return the translation returned by `gettext()`. To get the original string use this function.

Parameters

  it | The object item.
  part | The name of the part that was set

Returns
  The original, untranslated string

Since
  1.8

void elm_object_item_untrack | ( | Elm_Object_Item * | it | ) |

This retrieve the track object of the item.

Parameters

  it | The Elementary Object Item that returned track object.

Note
  This retrieves the track object that was returned from elm_object_item_track().

See Also
  elm_object_item_track()
  elm_object_item_track_get()

Since
  1.8

Evas_Object* elm_object_item_widget_get | ( | const Elm_Object_Item * | it | ) |

Get the widget object's handle which contains a given item.

Parameters

  it | The Elementary object item

Returns
  The widget object

Note
  This returns the widget object itself that an item belongs to.
  Every elm_object_item supports this API

Evas_Object* elm_object_name_find | ( | const Evas_Object * | obj,
|  | const char * | name,
|  | int | recurse
| ) |  |

Get a named object from the children.

Parameters

  obj | The parent object whose children to look at
  name | The name of the child to find
  recurse | Set to the maximum number of levels to recurse (0 == none, 1 is only look at 1 level of children etc.)

Returns
  The found object of that name, or NULL if none is found

This function searches the children (or recursively children of children and so on) of the given `obj` object looking for a child with the name of `name`. If the child is found the object is returned, or NULL is returned. You can set the name of an object with evas_object_name_set(). If the name is not unique within the child objects (or the tree is `recurse` is greater than 0) then it is undefined as to which child of that name is returned, so ensure the name is unique amongst children. If recurse is set to -1 it will recurse without limit.

Eina_Bool elm_object_orientation_mode_disabled_get | ( | const Evas_Object * | obj | ) |

Get the orientation mode of a given widget.

Parameters

  obj | The Elementary widget to query for its orientation mode.

Returns
  `EINA_TRUE`, if the orientation mode is disabled, `EINA_FALSE` if the orientation mode is enabled (or on errors)

See Also
  elm_object_orientation_mode_disabled_set()

Since
  1.8

void elm_object_orientation_mode_disabled_set | ( | Evas_Object * | obj,
|  | Eina_Bool | disabled
| ) |  |

Disable the orientation mode of a given widget.

Orientation Mode is used for widgets to change it's styles or to send signals whenever it's window degree is changed. If the orientation mode is enabled and the widget has different looks and styles for the window degree(0, 90, 180, 270), it will apply a style that is readied for the current degree, otherwise, it will send signals to it's own edje to change it's states if the style doesn't be readied.

Parameters

  obj | The Elementary object to operate on orientation mode.
  disabled | The state to put in in: `EINA_TRUE` for disabled, `EINA_FALSE` for enabled.

Since
  1.8

Evas_Object* elm_object_part_content_get | ( | const Evas_Object * | obj,
|  | const char * | part
| ) |  |

Get the content on a part of a given container widget.

Parameters

  obj | The Elementary container widget
  part | The container's part name to get (some might accept `NULL` for the default part)

Returns
  content of the object at the given part or `NULL`, on errors

See Also
  elm_object_part_content_set() for more details

void elm_object_part_content_set | ( | Evas_Object * | obj,
|  | const char * | part,
|  | Evas_Object * | content
| ) |  |

Set the content on part of a given container widget.

Parameters

  obj | The Elementary container widget
  part | The container's part name to set (some might accept `NULL` for the default part)
  content | The new content for that part

All widgets deriving from the The Elementary Container Class may hold child objects as content at given parts. This sets new content to a given part. If any object was already set as a content object in the same part, the previous object will be deleted automatically with this call. If the is NULL, this call will just delete the previous object. If the If you wish to preserve it, issue elm_object_part_content_unset() on it first.

See Also
  elm_object_part_content_get()

Evas_Object* elm_object_part_content_unset | ( | Evas_Object * | obj,
|  | const char * | part
| ) |  |

Unset the content on a part of a given container widget.

Parameters

  obj | The Elementary container widget
  part | The container's part name to unset (some might accept `NULL` for the default part)

Returns
  content of the object at the given part or `NULL`, on errors

See Also
  elm_object_part_content_set() for more details

const char* elm_object_part_text_get | ( | const Evas_Object * | obj,
|  | const char * | part
| ) |  |

Get a text of an object.

Parameters

  obj | The Elementary object
  part | The text part name to get (NULL for the default part)

Returns
  text of the part or NULL for any error

Note
  Elementary objects may have many text parts (e.g. Action Slider)

void elm_object_part_text_set | ( | Evas_Object * | obj,
|  | const char * | part,
|  | const char * | text
| ) |  |

Set a text of an object.

Parameters

  obj | The Elementary object
  part | The text part name to set (NULL for the default part)
  text | The new text of the part

Note
  Elementary objects may have many text parts (e.g. Action Slider)

void elm_object_signal_callback_add | ( | Evas_Object * | obj,
|  | const char * | emission,
|  | const char * | source,
|  | Edje_Signal_Cb | func,
|  | void * | data
| ) |  |

Add a callback for a signal emitted by widget edje object.

This function connects a callback function to a signal emitted by the edje object of the obj. Globs can occur in either the emission or source name.

Parameters

  obj | The object
  emission | The signal's name.
  source | The signal's source.
  func | The callback function to be executed when the signal is emitted.
  data | A pointer to data to pass to the callback function.

void* elm_object_signal_callback_del | ( | Evas_Object * | obj,
|  | const char * | emission,
|  | const char * | source,
|  | Edje_Signal_Cb | func
| ) |  |

Remove a signal-triggered callback from a widget edje object.

Parameters

  obj | The object handle
  emission | The signal's name.
  source | The signal's source.
  func | The callback function to be executed when the signal is emitted.

Returns
  The data pointer of the signal callback or `NULL`, on errors.

This function removes the last callback, previously attached to a signal emitted by an underlying Edje object of obj, whose parameters emission, source and `func` match exactly with those passed to a previous call to elm_object_signal_callback_add(). The data pointer that was passed to this call will be returned.

void elm_object_signal_emit | ( | Evas_Object * | obj,
|  | const char * | emission,
|  | const char * | source
| ) |  |

Send a signal to the widget edje object.

This function sends a signal to the edje object of the obj. An edje program can respond to a signal by specifying matching 'signal' and 'source' fields.

Parameters

  obj | The object
  emission | The signal's name.
  source | The signal's source.

const char* elm_object_translatable_part_text_get | ( | const Evas_Object * | obj,
|  | const char * | part
| ) |  |

Get the original string set as translatable for an object.

When setting translated strings, the function elm_object_part_text_get() will return the translation returned by `gettext()`. To get the original string use this function.

Parameters

  obj | The object
  part | The name of the part that was set

Returns
  The original, untranslated string

See Also
  elm_object_translatable_part_text_set()

Since
  1.8

Referenced by elm_object_translatable_text_part_get().

EINA_DEPRECATED const char* elm_object_translatable_text_part_get | ( | const Evas_Object * | obj,
|  | const char * | part
| ) |  |

Get the original string set as translatable for an object.

When setting translated strings, the function elm_object_part_text_get() will return the translation returned by `gettext()`. To get the original string use this function.

Parameters

  obj | The object
  part | The name of the part that was set

Returns
  The original, untranslated string

Deprecated:
  Use elm_object_translatable_part_text_get() instead.

References elm_object_translatable_part_text_get().

int elm_policy_get | ( | unsigned int | policy | ) |

Get the policy value for given policy identifier.

Parameters

  policy | policy identifier, as in Elm_Policy.

Returns
  The currently set policy value, for that identifier. Will be `0` if `policy` passed is invalid.

Referenced by elm_exit().

Eina_Bool elm_policy_set | ( | unsigned int | policy,
|  | int | value
| ) |  |

Set a new policy's value (for a given policy group/identifier).

Parameters

  policy | policy identifier, as in Elm_Policy.
  value | policy value, which depends on the identifier

Returns
  `EINA_TRUE` on success or `EINA_FALSE`, on error.

Elementary policies define applications' behavior, somehow. These behaviors are divided in policy groups (see Elm_Policy enumeration). This call will emit the Ecore event ELM_EVENT_POLICY_CHANGED, which can be hooked at with handlers. An Elm_Event_Policy_Changed struct will be passed, then.

Note
  Currently, we have only one policy identifier/group (ELM_POLICY_QUIT), which has two possible values.

Examples:
  actionslider_example_01.c, bg_example_01.c, bg_example_02.c, bg_example_03.c, box_example_02.c, bubble_example_01.c, button_example_00.c, button_example_01.c, calendar_example_01.c, calendar_example_02.c, calendar_example_03.c, calendar_example_04.c, calendar_example_05.c, calendar_example_06.c, check_example_01.c, clock_example.c, colorselector_example_01.c, conformant_example_01.c, conformant_example_02.c, ctxpopup_example_01.c, datetime_example.c, dayselector_example.c, diskselector_example_01.c, diskselector_example_02.c, efl_thread_1.c, efl_thread_2.c, efl_thread_3.c, efl_thread_4.c, efl_thread_5.c, efl_thread_6.c, entry_example.c, fileselector_button_example.c, fileselector_entry_example.c, fileselector_example.c, flip_example_01.c, flipselector_example.c, frame_example_01.c, general_funcs_example.c, gengrid_example.c, genlist_example_01.c, genlist_example_02.c, genlist_example_03.c, genlist_example_04.c, genlist_example_05.c, hover_example_01.c, hoversel_example_01.c, icon_example_01.c, image_example_01.c, index_example_01.c, index_example_02.c, inwin_example.c, label_example_01.c, layout_example_01.c, layout_example_02.c, layout_example_03.c, list_example_01.c, list_example_02.c, list_example_03.c, map_example_01.c, map_example_02.c, map_example_03.c, mapbuf_example.c, menu_example_01.c, notify_example_01.c, panel_example_01.c, panes_example.c, photocam_example_01.c, popup_example_01.c, popup_example_02.c, popup_example_03.c, prefs_example_01.c, prefs_example_02.c, prefs_example_03.c, radio_example_01.c, scroller_example_01.c, segment_control_example.c, separator_example_01.c, slider_example.c, slideshow_example.c, spinner_example.c, table_example_01.c, table_example_02.c, theme_example_01.c, theme_example_02.c, thumb_example_01.c, toolbar_example_01.c, toolbar_example_02.c, toolbar_example_03.c, transit_example_01.c, transit_example_02.c, and web_example_02.c.

References _Elm_Event_Policy_Changed::new_value, _Elm_Event_Policy_Changed::old_value, and _Elm_Event_Policy_Changed::policy.

void elm_run | ( | void |  | ) |

Run Elementary's main loop.

This call should be issued just after all initialization is completed. This function will not return until elm_exit() is called. It will keep looping, running the main (event/processing) loop for Elementary.

See Also
  elm_init() for an example

Examples:
  actionslider_example_01.c, bg_example_01.c, bg_example_02.c, bg_example_03.c, box_example_02.c, bubble_example_01.c, button_example_00.c, button_example_01.c, calendar_example_01.c, calendar_example_02.c, calendar_example_03.c, calendar_example_04.c, calendar_example_05.c, calendar_example_06.c, check_example_01.c, clock_example.c, colorselector_example_01.c, conformant_example_01.c, conformant_example_02.c, ctxpopup_example_01.c, datetime_example.c, dayselector_example.c, diskselector_example_01.c, diskselector_example_02.c, efl_thread_1.c, efl_thread_2.c, efl_thread_3.c, efl_thread_4.c, efl_thread_5.c, efl_thread_6.c, entry_example.c, fileselector_button_example.c, fileselector_entry_example.c, fileselector_example.c, flip_example_01.c, flipselector_example.c, frame_example_01.c, general_funcs_example.c, gengrid_example.c, genlist_example_01.c, genlist_example_02.c, genlist_example_03.c, genlist_example_04.c, genlist_example_05.c, hover_example_01.c, hoversel_example_01.c, icon_example_01.c, image_example_01.c, index_example_01.c, index_example_02.c, inwin_example.c, label_example_01.c, layout_example_01.c, layout_example_02.c, layout_example_03.c, list_example_01.c, list_example_02.c, list_example_03.c, map_example_01.c, map_example_02.c, map_example_03.c, mapbuf_example.c, menu_example_01.c, notify_example_01.c, panel_example_01.c, panes_example.c, photocam_example_01.c, popup_example_01.c, popup_example_02.c, popup_example_03.c, prefs_example_01.c, prefs_example_02.c, prefs_example_03.c, progressbar_example.c, radio_example_01.c, scroller_example_01.c, segment_control_example.c, separator_example_01.c, slider_example.c, slideshow_example.c, spinner_example.c, table_example_01.c, table_example_02.c, theme_example_01.c, theme_example_02.c, thumb_example_01.c, toolbar_example_01.c, toolbar_example_02.c, toolbar_example_03.c, transit_example_01.c, transit_example_02.c, web_example_02.c, and win_example.c.

int elm_shutdown | ( | void |  | ) |

Shut down Elementary.

Returns
  The init counter value.

This should be called at the end of your application, just before it ceases to do any more processing. This will clean up any permanent resources your application may have allocated via Elementary that would otherwise persist.

See Also
  elm_init() for an example

Note
  elm_shutdown() will iterate main loop until all ecore_evas are freed. There is a possibility to call your ecore callbacks(timer, animator, event, job, and etc.) in elm_shutdown()

Examples:
  actionslider_example_01.c, bg_example_01.c, bg_example_02.c, bg_example_03.c, box_example_02.c, bubble_example_01.c, button_example_00.c, button_example_01.c, calendar_example_01.c, calendar_example_02.c, calendar_example_03.c, calendar_example_04.c, calendar_example_05.c, calendar_example_06.c, check_example_01.c, clock_example.c, colorselector_example_01.c, conformant_example_01.c, conformant_example_02.c, ctxpopup_example_01.c, datetime_example.c, dayselector_example.c, diskselector_example_01.c, diskselector_example_02.c, efl_thread_1.c, efl_thread_2.c, efl_thread_3.c, efl_thread_4.c, efl_thread_5.c, efl_thread_6.c, entry_example.c, fileselector_button_example.c, fileselector_entry_example.c, fileselector_example.c, flip_example_01.c, flipselector_example.c, frame_example_01.c, general_funcs_example.c, gengrid_example.c, genlist_example_01.c, genlist_example_02.c, genlist_example_03.c, genlist_example_04.c, genlist_example_05.c, hover_example_01.c, hoversel_example_01.c, icon_example_01.c, image_example_01.c, index_example_01.c, index_example_02.c, inwin_example.c, label_example_01.c, layout_example_01.c, layout_example_02.c, layout_example_03.c, list_example_01.c, list_example_02.c, list_example_03.c, map_example_01.c, map_example_02.c, map_example_03.c, mapbuf_example.c, menu_example_01.c, notify_example_01.c, panel_example_01.c, panes_example.c, photocam_example_01.c, popup_example_01.c, popup_example_02.c, popup_example_03.c, prefs_example_01.c, prefs_example_02.c, prefs_example_03.c, progressbar_example.c, radio_example_01.c, scroller_example_01.c, segment_control_example.c, separator_example_01.c, slider_example.c, slideshow_example.c, spinner_example.c, table_example_01.c, table_example_02.c, theme_example_01.c, theme_example_02.c, thumb_example_01.c, toolbar_example_01.c, toolbar_example_02.c, toolbar_example_03.c, transit_example_01.c, transit_example_02.c, web_example_02.c, and win_example.c.

References elm_quicklaunch_shutdown(), and elm_quicklaunch_sub_shutdown().

Copyright ©2000-2014 Enlightenment.org - Samsung Electronics supports the EFL Documentation Project - Generated Wed Jan 8 2014 20:51:13